---
title: Firefox 21 for developers
slug: Mozilla/Firefox/Releases/21
tags:
  - Firefox
  - Mozilla
---
<div>{{FirefoxSidebar}}</div>

<p>Firefox 21 was released on May 14, 2013. This article lists key changes that are useful not only for web developers, but also Firefox and Gecko developers as well as add-on developers.</p>

<h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="HTML">HTML</h3>

<ul>
 <li>The {{htmlattrxref("scoped", "style")}} attribute has been added to the {{HTMLElement("style")}} element. It allows to include styles that are isolated from the rest of the document. Such styles can be selected using the {{cssxref(":scope")}} CSS pseudo-element introduced in Firefox 20. ({{bug("508725")}}).</li>
 <li>The new HTML {{HTMLElement("main")}} element has been implemented ({{bug("820508")}}).</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li><a href="/en-US/docs/E4X" title="E4X">E4X</a>, an ancient JavaScript extension, has been removed. Implemented only in Gecko, it never got significant traction ({{bug("788293")}}).</li>
 <li><a href="/en-US/docs/JavaScript/Reference/Global_Objects/parseInt">parseInt</a> no longer treats strings with leading "0" as octal ({{bug("786135")}}).</li>
</ul>

<h3 id="CSS">CSS</h3>

<ul>
 <li>The <code>none</code> value of {{cssxref("user-select", "-moz-user-select")}} has now the same behavior than the <code>-moz-none</code> value, aligning Gecko on WebKit (Chrome, Safari), Presto (Opera) and Trident (Internet Explorer) ({{bug("816298")}}).</li>
 <li>On XHTML content, the <code>auto</code> value of {{cssxref("hyphens", "-moz-hyphens")}} incorrectly applied hyphenation rules when the language was not explicitly declared. This is fixed by ({{bug("702121")}}).</li>
 <li>An <code>auto</code> value has been added to the CSS {{cssxref("-moz-orient")}} property. The <code>auto</code> value is equivalent to <code>horizontal</code> when applied to {{HTMLElement("meter")}} and {{HTMLElement("progress")}} ({{bug("835883")}}).</li>
 <li>The media query <a href="/en-US/docs/Web/Guide/CSS/Media_queries#-moz-windows-glass"><code>-moz-windows-glass</code></a> has been added on Windows 7 and earlier Windows system ({{bug("816803")}}).</li>
</ul>

<h3 id="DOM">DOM</h3>

<ul>
 <li>Support for {{domxref("RTCPeerConnection")}} (as <code>MozRTCPeerConnection</code>) is now enabled by default ({{bug(796463)}}). It can be disabled again if necessary by setting {{pref("media.peerconnection.enabled")}} to false.</li>
 <li>The <code>origin</code> property has been added to the {{domxref("window.location")}} ({{bug("828261")}}).</li>
 <li>The <code>valueAsDate</code> and <code>valueAsNumber</code> methods have been added for <code>&lt;input type="time"&gt;</code> ({{bug("781570")}}).</li>
 <li>The <code>min</code> and <code>max</code> attributes now apply to <code>&lt;input type="time"&gt;</code> too ({{bug("781572")}}).</li>
 <li>Some new keyCodes for volume control are supported ({{bug("674739")}}).</li>
 <li>Some new keyCodes for ancient keyboard layout such as AS/400 are now supported on Windows and Linux ({{bug("833719")}}).</li>
 <li>Various keyCode values for OEM sepecific keys on Windows are now supported again ({{bug("833719")}}).</li>
 <li>The function <a href="/en-US/docs/DOM/window.crypto.getRandomValues" title="DOM/window.crypto.getRandomValues"><code>window.crypto.getRandomValues</code></a> has been implemented ({{bug("440046")}}).</li>
 <li>The methods {{domxref("NodeIterator.expandEntityReferences()")}} and {{domxref("TreeWalker.expandEntityReferences()")}}, no more in the latest DOM spec, has been removed ({{bug("672190")}}).</li>
 <li>CSSOM: the method {{domxref("CSSKeyframesRule")}}<code>.insertRule</code> has been removed to {{domxref("CSSKeyframesRule")}}<code>.appendRule</code> to match a spec change ({{bug("841896")}}).</li>
 <li>CSSOM If the given parameter given to {{domxref("CSSStyleSheet.insertRule")}} contains more than one rule, a {{domxref("DOMException")}} with a <code>SYNTAX_ERR</code> is now thrown ({{bug("765599")}}).</li>
 <li>Until now, when the same headers were repeatedly set with <a href="/en-US/docs/Web/API/XMLHttpRequest#setRequestHeader"><code>XMLHttpRequest.setRequestHeader</code></a>, the last-specified value was used. This behavior has been changed to comply with the spec, so those values will be properly combined ({{bug("819051")}}).</li>
</ul>

<h3 id="SVG">SVG</h3>

<ul>
 <li>The <a href="/en-US/docs/Web/SVG/Attribute/paint-order">paint-order</a> attribute has been implemented ({{bug("828805")}}).</li>
 <li>The <code>svg.smil.enabled</code> preference has been removed. SMIL is always on. ({{bug(835030)}})</li>
</ul>

<h3 id="Networking">Networking</h3>

<ul>
 <li>We continue to update our CSP implementation to match the CSP 1.0 spec, which reached Candidate Recommendation:
  <ul>
   <li>Support for the spec-compliant <span id="summary_alias_container"><span id="short_desc_nonedit_display"><code>Content-Security-Policy</code> HTTP header (in addition to the experimental </span></span><span id="summary_alias_container"><span id="short_desc_nonedit_display"><code>X-Content-Security-Policy</code>) has been added ({{bug("783049")}}). <strong>Note</strong>: the patch for this new header landed in Firefox 21, it is disabled on builds</span></span> ({{bug("842657")}}).</li>
  </ul>
 </li>
</ul>

<h3 id="Worker">Worker</h3>

<ul>
 <li>The functions {{domxref("window.URL.createObjectURL", "URL.createObjectURL")}} and {{domxref("window.URL.revokeObjectURL", "URL.revokeObjectURL")}} are now included in the set of <a href="/en-US/docs/DOM/Worker/Functions_available_to_workers" title="DOM/Worker/Functions_available_to_workers">functions available to workers</a>.</li>
</ul>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<ul>
 <li>FUEL applications cannot use the Livemarks service anymore ({{bug("834492")}}). The Livemarks service is deprecated and phased out in favor of the new async interface.</li>
 <li><code>resource:///modules/</code> and <code>resource://gre/modules/</code> are no longer identical ({{bug("755724")}}). This change was made because of work on the metro version of Firefox. If you load modules using <code>resource:///modules/</code>, you should check if you now want to use <code>resource://gre/modules/</code> instead. Note that some modules also moved from Firefox to Toolkit ({{bug("840287")}} and {{bug("811548")}} moved <code>NewTabUtils.jsm</code> and the thumbnail modules, respectively).</li>
 <li>The Add-on SDK is now included in Firefox ({{bug("731779")}})</li>
 <li>History API saw numerous deprecated API being removed:
  <ul>
   <li>Replaced by <code>mozIAsyncFavicons</code>:
    <ul>
     <li><code>nsIFaviconService::setFaviconUrlForPage</code></li>
     <li><code>nsIFaviconService::setFaviconData</code></li>
     <li><code>nsIFaviconService::getFaviconData</code></li>
     <li><code>nsIFaviconService::getFaviconForPage</code></li>
     <li><code>nsIFaviconService::setAndLoadFaviconForPage</code></li>
     <li><code>nsIFaviconService::getFaviconImageForPage</code></li>
     <li><code>nsIFaviconService::getFaviconDataAsDataURL</code></li>
    </ul>
   </li>
   <li>Replaced by <code>mozIAsyncLivemarks</code>:
    <ul>
     <li><code>nsILivemarkService::*</code></li>
     <li><code>PlacesUtils.itemIsLivemark</code></li>
     <li><code>PlacesUtils.nodeIsLivemarkContainer</code></li>
     <li><code>PlacesUtils.nodeIsLivemarkItem</code></li>
    </ul>
   </li>
   <li>Removed only third argument:
    <ul>
     <li><code>PlacesUIUtils.showBookmarkDialog</code></li>
    </ul>
   </li>
   <li>No more implemented by Places, use <code>mozIAsyncHistory</code> instead:
    <ul>
     <li><code>nsIGlobalHistory2::addURI</code></li>
     <li><code>nsIGlobalHistory2::isVisited</code></li>
     <li><code>nsIGlobalHistory2::setPageTitle</code></li>
    </ul>
   </li>
   <li>No more needed, use <code>onDeleteURI</code> or <code>onItemRemoved</code>:
    <ul>
     <li><code>nsINavHistoryObserver::OnBeforeDeleteURI</code></li>
     <li><code>nsINavBookmarkObserver::OnBeforeItemRemoved</code></li>
    </ul>
   </li>
   <li>Never implemented properly:
    <ul>
     <li><code>nsINavHistoryFullVisitResultNode</code></li>
    </ul>
   </li>
   <li>Deprecated, use<code> mozIAsyncHistory::updatePlaces</code> instead:
    <ul>
     <li><code>nsINavHistoryService::AddVisit</code></li>
    </ul>
   </li>
  </ul>
 </li>
 <li>Added <a href="/en-US/docs/">nsIHttpChannel.redirectTo</a> to enable redirecting HTTP channels without fragile hacks.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="http://www.mozilla.org/en-US/firefox/21.0/releasenotes/">Firefox 21 Release Notes</a></li>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/21/">Site Compatibility for Firefox 21</a></li>
 <li><a href="https://blog.mozilla.org/addons/2013/04/26/compatibility-for-firefox-21/">Add-on Compatibility for Firefox 21</a></li>
</ul>

<h3 id="Older_versions">Older versions</h3>

<div>{{Firefox_for_developers('20')}}</div>
